#!/usr/bin/env python
#-*- coding:utf-8 -*-

import pygtk
pygtk.require("2.0")
import gtk
import os
import sys
import inifile8
import maindata

class SeeMe4(gtk.Window):
    """
        SeeMe Main Window Class
    """
    def __init__(self, sset):
        gtk.Window.__init__(self)
        self.sset = sset
        self.connect("delete-event", self.on_quit)
        self.resize(sset.width, sset.height)
        self.show_all()

    def messagebox(self, text):
        dlg = gtk.MessageDialog(self, gtk.DIALOG_MODAL, gtk.MESSAGE_WARNING, 
                                gtk.BUTTONS_OK, text)
        dlg.set_title("確認 - seeme")  
        r = dlg.run()  
        dlg.destroy()

    def on_quit(self, widget, event=None):
        gtk.main_quit()

########################################################################
#
#                               Welcome
#
########################################################################


class WelcomeDlg():
    def __init__(self, sset):
        """
            Welcome Dialog
        """
        self.w = gtk.Dialog("SeeMe へようこそ", 
                            None,
                            gtk.DIALOG_MODAL,
                            (gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT,
                            gtk.STOCK_OK, gtk.RESPONSE_ACCEPT) )
        description = gtk.Label("SeeMe の初期設定を行います、各項目のチェックをお願いします\n初回起動では Opera 10 beta のデフォルト位置を示しています")
        self.w.vbox.pack_start(description, False, False)
        sp = gtk.HSeparator()
        self.w.vbox.pack_start(sp, False)
        names = ["Default search.ini", "Custome search.ini", "operaprefs.ini", "lng File"]
        self.entrys = []
        for name in names:
            hbox = gtk.HBox()
            label = gtk.Label(name)
            label.set_size_request(150, -1)
            entry = gtk.Entry()
            hbox.pack_start(label, False, False)
            hbox.pack_start(entry)
            self.w.vbox.pack_start(hbox, False, False)
            self.entrys.append(entry)
        if sset.default_path == "":
            self.entrys[0].set_text("/usr/share/opera/locale/en/search.ini")
        else:
            self.entrys[0].set_text(sset.default_path)
        if sset.custome_path == "":
            s = os.path.expanduser("~/.opera/search.ini")
            self.entrys[1].set_text(s)
        else:
            self.entrys[1].set_text(sset.custome_path)
        if sset.prefs_path == "":
            s = os.path.expanduser("~/.opera/operaprefs.ini")
            self.entrys[2].set_text(s)
        else:
            self.entrys[2].set_text(sset.prefs_path)
        if sset.lang_path == "":
            self.entrys[3].set_text("/usr/share/opera/locale/en/en.lng")
        else:
            self.entrys[3].set_text(sset.lang_path)
        self.w.set_size_request(500, -1)
        self.w.show_all()

########################################################################
#
#                               main
#
########################################################################


def messagebox(text):
    dlg = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_WARNING, 
                            gtk.BUTTONS_OK, text)
    dlg.set_title("確認 - seeme")  
    r = dlg.run()  
    dlg.destroy()

def main():
    inipath = os.path.expanduser("~/.seeme/seeme4.ini")
    sset = maindata.SeeMeSetting()
    #if os.path.exists(inipath):
    ini = inifile8.Inifile(inipath)
    try:
        sset.version = ini.read_int("Version", "File Version", 0)
        sset.width = ini.read_int("Window", "Width", 500)
        sset.height = ini.read_int("Window", "Height", 500)
        sset.top = ini.read_int("Window", "Top", 100)
        sset.left = ini.read_int("Window", "Left", 100)
        sset.default_path = ini.read_str("Path", "Default1", "")
        sset.custome_path = ini.read_str("Path", "Custome1", "")
        sset.prefs_path = ini.read_str("Path", "Prefs1", "")
        sset.lang_path = ini.read_str("Path", "Lang1", "")
        sset.default_path2 = ini.read_str("Path", "Default2", "")
        sset.custome_path2 = ini.read_str("Path", "Custome2", "")
        sset.prefs_path2 = ini.read_str("Path", "Prefs2", "")
        sset.lang_path2 = ini.read_str("Path", "Lang2", "")
        sset.texteditor = ini.read_str("Setting", "Editor", "")
        sset.verbtext = ini.read_int("Setting", "Verbtext", 0)
    except Exception, s:
        messagebox("%s" % s)
        sys.exit()
    if sset.version < 1:
        dlg = WelcomeDlg(sset)
        try:
            if dlg.w.run() == gtk.RESPONSE_ACCEPT:
                sset.default_path = dlg.entrys[0].get_text()
                sset.custome_path = dlg.entrys[1].get_text()
                sset.prefs_path =   dlg.entrys[2].get_text()
                sset.lang_path =    dlg.entrys[3].get_text()
            else:
                sys.exit()
        except Exception, s:
            self.messagebox("%s" % s)
        finally:
            dlg.w.destroy()
    SeeMe4(sset)
    gtk.main()

if __name__ == "__main__":
    main()
